
<p>Pogledajmo ponovno što nam kaže Shannonov teorem:
$$
 f(x_1,\ldots,x_i,\ldots,x_n) = \bar x_i \cdot f_{x_i=0} + x_i \cdot f_{x_i=1}.
$$
Proizvoljna funkcija \(f\) može se prikazati u danom obliku.
</p>

<p>Čemu je, prema tom izrazu, jednaka funkcija \(f\) kada je \(x_i = 0\)? Idemo uvrstiti:
$$
\begin{align}
 f(x_1,\ldots,x_{i-1},0,x_{i+1},\ldots,x_n) &amp;= \left. \bar x_i \cdot f_{x_i=0} + x_i \cdot f_{x_i=1} \right|_{x_i=0} \\
  &amp;= \bar 0 \cdot f_{x_i=0} + 0 \cdot f_{x_i=1} \\
  &amp;= 1 \cdot f_{x_i=0} + 0 \cdot f_{x_i=1} \\
  &amp; f_{x_i=0}.
\end{align}
$$
A čemu je, prema istom izrazu, jednaka funkcija \(f\) kada je \(x_i = 1\)? Idemo to uvrstiti:
$$
\begin{align}
 f(x_1,\ldots,x_{i-1},1,x_{i+1},\ldots,x_n) &amp;= \left. \bar x_i \cdot f_{x_i=0} + x_i \cdot f_{x_i=1} \right|_{x_i=0} \\
  &amp;= \bar 1 \cdot f_{x_i=0} + 1 \cdot f_{x_i=1} \\
  &amp;= 0 \cdot f_{x_i=0} + 1 \cdot f_{x_i=1} \\
  &amp;= f_{x_i=1} \\
\end{align}
$$
Shannonov nam teorem, dakle, omogućava da kažemo sljedeće: vrijednost funkcije \(f\) jednaka je vrijednosti funkcije \(f_{x_i=0}\) kada je \(x_i=0\) odnosno vrijednosti funkcije \(f_{x_i=1}\) kada je \(x_i=1\). U programskom jeziku C, takvo ponašanje bi odgovaralo naredbi <code>if</code>:</p>

<pre><code>int f(int xi, int fxi0, int fxi1) {
  if(xi==0) {
    return fxi0;
  } else {
    return fxi1;
  }
}</code></pre>

<p>ili pak uporabi ternarnog operatora u dodjeljivanju:</p>

<pre><code>f = xi==0 ? fxi0 : fxi1;</code></pre>

<p>U sklopovskim implementacijama Shannonov teorem se koristi kao sklop za odabir (odnosno selekciju) podataka u ovisnosti o vrijednosti neke ispitivane varijable. U tom smislu, početni izraz:
$$
 f(x_1,\ldots,x_i,\ldots,x_n) = \bar x_i \cdot f_{x_i=0} + x_i \cdot f_{x_i=1}.
$$
se malo modificira na način da funkciju označimo s \(y\), varijablu \(x_i\) nazovemo adresnom varijablom (oznaka \(a\)) ili ponekad selekcijskom varijablom (oznaka \(s\)), a rezidualne funkcije \(f_{x_i=0}\) i \(f_{x_i=1}\) nazovemo nultim i prvim podatkovnim ulazom (oznake \(d_0\) i \(d_1\) gdje \(d\) dolazi od engleskog termina <i>data</i>), pa tada izraz pišemo na sljedeći način:
$$
  y = \bar s \cdot d_0 + s \cdot d_1.
$$
Sklopovsko ostvarenje ovog izraza nazivamo <em>multipleksor 2/1</em> (čitamo "multipleksor dva-na-jedan"): broj 2 u oznaci multipleksora označava da postoje dva podatkovna ulaza a broj 1 da sklop ima jedan izlaz.
</p>

<div class="mlImportant">
<p>Pogledajte još jednom ovaj posljednji izraz i zapamtite ga. Izraz nam kaže sljedeće: \(y\) je jednak \(d_0\) kada je \(s=0\) odnosno \(d_1\) kada je \(s=1\). Izraz predstavlja sklopovsku implementaciju naredbe <code>if</code> i koristi se kao selektor podataka.</p>
</div>

<p>Uobičajeni simbol ovog sklopa prikazan je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(mux21.svg)" alt="Multipleksor 2/1"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Simbol multipleksora 2/1.</figcaption>
</figure>

<p>Evo primjera. Ako na multipleksor sa slike 1 dovedemo \(d_0=1\), \(d_1=0\) te \(s=1\), na izlazu \(y\) pojavit će se vrijednost 0 jer za \(s=1\) multipleksor na svoj izlaz propušta što god da je dovodeno na podatkovni ulaz \(d_1\), što je u ovom slučaju vrijednost 0.</p>

<p>Interaktivna simulacija ovog sklopa prikazana je u nastavku. Crvena crtkana linija prikazuje koji se ulaz prospaja na izlaz multipleksora; nju obično ne crtamo na simbolu multipleksora ali sada je prikazana kako bi rad sklopa bio jasniji. Probajte mijenjati vrijednost koja se dovodi na selekcijski (adresni) ulaz te vrijednosti koje se dovode na podatkovne ulaze. Vrijednosti možete mijenjati klikom miša.</p>
 
<script>
@#page-include#(multiplexer.js)
@#page-include#(multiplexer-util.js)
</script>

<div style="text-align: center;">
<canvas id="multiplexerCanvas" width="320" height="260" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
  var tmp = setupMultiplexer("multiplexerCanvas", [1, 0], false);
  tmp.multiplexer.setPathVisible(true);
  tmp.multiplexer.drawAll();
</script>

<p>Multipleksor može imati i dodatni ulaz za omogućavanje koji označavamo slovom E (od engleskog <i>enable</i>). Ako se na ulaz E dovede vrijednost 0, multipleksor je onemogućen i tada je njegov izlaz postavljen na vrijednost 0, neovisno o vrijednostima koje su dovedene na selekcijske i podatkovne ulaze. Ako je na ulaz E dovedena vrijednost 1, multipleksor na uobičajen način obavlja svoju funkciju. Interaktivna simulacija takvog multipleksora prikazana je u nastavku. Sada klikom miša možete mijenjati i vrijednost koja se dovodi na ulaz E - isprobajte.</p>

<div style="text-align: center;">
<canvas id="multiplexerCanvas2" width="320" height="260" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
  var tmp2 = setupMultiplexer("multiplexerCanvas2", [1, 0], true);
  tmp2.multiplexer.setPathVisible(true);
  tmp2.multiplexer.drawAll();
</script>

<h3>Veći multipleksori</h3>

<p>Rekurzivnom uporabom Shannonovog teorema možemo doći i do većih multipleksora. Neka je prvi korak dekompozicija funkcije po varijabli \(x_i\). Prema Shannonovom teoremu možemo pisati:
$$
 f(x_1,\ldots,x_i,\ldots,x_n) = \bar x_i \cdot f_{x_i=0} + x_i \cdot f_{x_i=1}.
$$
Rezidualne funkcije \(f_{x_i=0}\) i \(f_{x_i=1}\) pri tome ovise o svim varijablama osim varijable \(x_i\). Odaberimo sada jednu drugu varijablu, \(x_j\), i obje rezidualne funkcije dekomponirajmo po toj varijabli. Možemo pisati:
$$
 f_{x_i=0} = \bar x_j \cdot f_{x_i=0,x_j=0} + x_j \cdot f_{x_i=0,x_j=1} \\
 f_{x_i=1} = \bar x_j \cdot f_{x_i=1,x_j=0} + x_j \cdot f_{x_i=1,x_j=1} \\
$$
čime smo dobili četiri nove rezidualne funkcije: \(f_{x_i=0,x_j=0}\), \(f_{x_i=0,x_j=1}\), \(f_{x_i=1,x_j=0}\) i \(f_{x_i=1,x_j=1}\). Svaka od tih funkcija dobiva se tako da se u početnu funkciju uvrste specificirane vrijednosti varijabli \(x_i\) i \(x_j\). Uočite također da su ove rezidualne funkcije sada funkcije od preostalih <i>n</i>-2 varijable.</p>

<p>Dobiveni raspis funkcija sada možemo uvrstiti u početnu dekompoziciju čime dobivamo:
$$
 \begin{align}
   f(x_1,\ldots,x_n) &amp;= \bar x_i \cdot \left( \bar x_j \cdot f_{x_i=0,x_j=0} + x_j \cdot f_{x_i=0,x_j=1} \right) + x_i \cdot \left( \bar x_j \cdot f_{x_i=1,x_j=0} + x_j \cdot f_{x_i=1,x_j=1} \right) \\
  &amp;= \bar x_i \bar x_j \cdot f_{x_i=0,x_j=0} + \bar x_i x_j \cdot f_{x_i=0,x_j=1} + x_i \bar x_j \cdot f_{x_i=1,x_j=0} + x_i x_j \cdot f_{x_i=1,x_j=1}
 \end{align}
$$
</p>

<p>Dobiveni izraz iskoristit ćemo za ostvarivanje multipleksora 4/1. Pogledajte najprije produkte koji množe svaku od rezidualnih funkcija. To su produkti varijabli \(x_i\) i \(x_j\) koji su ostvareni na sljedeći način: u prvom, obje su varijable komplementirane, u drugom prva je a druga nije, u trećem prva nije a druga je, u četvrtom niti jedna nije. Pridijelimo li binarne uzorke tim produktima na uobičajeni način (komplement označimo s 0, varijablu bez komplementa s 1), imamo redom uzorke 00, 01, 10 i 11, odnosno pročitamo li to kao binarno zapisane brojeve, radi se o brojevima 0, 1, 2 i 3. Svaki "broj" množi pripadnu rezidualnu funkciju kojih ima upravo 4.</p>

<p>Kao što smo napravili kod multipleksora 2/1, i sada ćemo napraviti preimenovanje varijabli. \(x_i\) i \(x_j\) ćemo (tim redosljedom) preimenovati u \(s_1\) i \(s_0\) što će nam omogućiti da govorimo o dvobitnom ulazu \(s\) koji može biti 0, 1, 2 ili 3. Važno je pri tome zapamtiti da se pridržavamo sljedeće prakse: selekcijski bit veće težine postaje varijabla po kojoj smo najprije radili dekompoziciju: iz tog razloga \(x_i\) mijenjamo sa \(s_1\) a \(x_j\) sa \(s_0\).
Rezidualne funkcije \(f_{x_i=0,x_j=0}\), \(f_{x_i=0,x_j=1}\), \(f_{x_i=1,x_j=0}\) i \(f_{x_i=1,x_j=1}\) preimenovat ćemo (tim redosljedom) u \(d_0\), \(d_1\), \(d_2\) i \(d_3\). Samu funkciju preimenovat ćemo u \(y\). Tada možemo pisati:
$$
  y = \bar s_1 \bar s_0 \cdot d_0 + \bar s_1 s_0 \cdot d_1 + s_1 \bar s_0 \cdot d_2 + s_1 s_0 \cdot d_3.
$$
Simbol sklopovskog ostvarenja ovog izraza prikazan je na slici 2 i naziva se multipleksor 4/1.
</p>

<figure class="mlFigure">
<img src="@#file#(mux41.svg)" alt="Multipleksor 4/1"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Simbol multipleksora 4/1.</figcaption>
</figure>

<p>
Uočite kako je prethodni algebarski izraz građen: produkti \(\bar s_1 \bar s_0\), \(\bar s_1 s_0\), \(s_1 \bar s_0\) i \(s_1 s_0\) množe vrijednosti koje se dovode na ulaze \(d_0\), \(d_1\), \(d_2\) i \(d_3\). Pri tome će, za bilo koju konkretnu kombinaciju vrijednosti \(s_1\) i \(s_0\), samo jedan od tih produkata biti 1 i čitav će se izraz pojednostavniti upravo u vrijednost pripadnog podatkovnog ulaza. S donje strane simbola su prikazani selekcijski bitovi. Nalazi li se selekcijski bit veće težine skroz lijevo ili skroz desno nije bitno, tako dugo dok se pridržavamo dogovora da veći indeks označava veću težinu.
</p>

<p>
Interaktivna simulacija multipleksora 4/1 s ulazom za omogućavanje dana je u nastavku. Isprobajte kako se ponaša ovakav multipleksor.
</p>

<div style="text-align: center;">
<canvas id="multiplexerCanvas3" width="320" height="260" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
  var tmp3 = setupMultiplexer("multiplexerCanvas3", [1, 0, 0, 1], true);
  tmp3.multiplexer.setPathVisible(true);
  tmp3.multiplexer.drawAll();
</script>

<p>U programiranju, veći su multipleksori ekvivalent naredbi <code>switch</code> u kontekstu dodjeljivanja vrijednosti. Konkretno, multipleksor 4/1 bi bio ekvivalent funkciji:</p>

<pre><code>int f(int s, int d0, int d1, int d2, int d3) {
  if(s==0) {
    return d0;
  } else if(s==1) {
    return d1;
  } else if(s==2) {
    return d2;
  } else {
    return d3;
  }
}</code></pre>

<p>ili pak:</p>

<pre><code>int f(int s, int d0, int d1, int d2, int d3) {
  switch(s) {
    case 0: return d0;
    case 1: return d1;
    case 2: return d2;
    default: return d3;
  }
}</code></pre>

<p>ili pak uporabi ternarnog operatora u dodjeljivanju:</p>

<pre><code>f = s==0 ? d0 : (s==1 ? d1 : (s==2 ? d2 : d3));</code></pre>

<p>Znamo li sada napisati kako bi izgledao algebarski izraz multipleksora 8/1? On bi imao osam podatkovnih ulaza (\(d_0\) do \(d_7\)), tri selekcijska ulaza (\(s_2,s_1,s_0\)) i jedan izlaz. Algebarski izraz kojim je određen izlaz takvog multipleksora je:
$$
  y = \bar s_2 \bar s_1 \bar s_0 \cdot d_0 + \bar s_2 \bar s_1 s_0 \cdot d_1 + \bar s_2 s_1 \bar s_0 \cdot d_2 + \bar s_2 s_1 s_0 \cdot d_3 + s_2 \bar s_1 \bar s_0 \cdot d_4 + s_2 \bar s_1 s_0 \cdot d_5 + s_2 s_1 \bar s_0 \cdot d_6 + s_2 s_1 s_0 \cdot d_7.
$$
Algebarski izrazi koji opisuju još veće multipleksore građeni su na ekvivalentni način. 
</p>

<p>
Interaktivna simulacija multipleksora 8/1 s ulazom za omogućavanje dana je u nastavku. Isprobajte kako se ponaša ovakav multipleksor.
</p>

<div style="text-align: center;">
<canvas id="multiplexerCanvas4" width="320" height="260" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
  var tmp4 = setupMultiplexer("multiplexerCanvas4", [1, 0, 0, 1, 1, 1, 0, 0], true);
  tmp4.multiplexer.setPathVisible(true);
  tmp4.multiplexer.drawAll();
</script>

<div class="mlNote">
<p>Multipleksore označavamo oznakom "multipleksor <i>n</i>/1" gdje je <i>n</i> broj podatkovnih ulaza. U digitalnim sklopovima taj je broj tipično oblika \(2^k\) gdje je \(k\) broj selekcijskih bitova. Tako smo imali multipleksor 2/1 koji je imao \(k=1\) selekcijski bit, multipleksor 4/1 koji je imao \(k=2\) selekcijska bita, multipleksor 8/1 koji je imao \(k=3\) selekcijska bita, itd.</p>
<p>Multipleksori se koriste kao selektori podataka. Multipleksori se mogu koristiti i za ostvarivanje Booleovih funkcija.</p>
</div>

